<?php

class NarkomSu_Category extends NarkomSu implements UserInputHandler
{
    const ID = 'UaKinoNet_Category_ID';

    function handle_user_input(&$user_input, &$plugin_cookies) {}

    /**
     *
     * @return type 
     */
    function get_handler_id()
    {
        return self::ID;
    }

    /**
     *
     * @return type 
     */
    function favorites($conf_path)
    {
        $favorites = array();

        foreach (get_object_vars(FavoritesList::get()) as $key => $value)
        {
            if (isset($value->title))
            {
                $item = array('title' => $value->title, 'media_url' => $value->media_url, 'image' => $value->poster);
                array_push($favorites, $item);
            }
        }

        $favorites = array_reverse($favorites);

        $remove = UserInputHandlerRegistry::create_action($this, 'remove_fav');
        $remove['caption'] = 'Удалить с избранного';

        $menu_items[] = array(
            GuiMenuItemDef::caption => $remove['caption'],
            GuiMenuItemDef::action => $remove
        );
        $popup_search_action = ActionFactory::show_popup_menu($menu_items);
        
        
        $actions = array
            (
            GUI_EVENT_KEY_ENTER => array(GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID),
            GUI_EVENT_KEY_C_YELLOW => $remove,
            GUI_EVENT_KEY_POPUP_MENU => $popup_search_action,
        );

        $items = array();

        foreach ($favorites as $item)
        {
            array_push
                    (
                    $items, array
                (
                PluginRegularFolderItem::caption => $item['title'],
                PluginRegularFolderItem::starred => true,
                PluginRegularFolderItem::view_item_params => array
                    (
                    ViewItemParams::icon_path => $item['image'],
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_sel_scale_factor => 1.28,
                    ViewItemParams::icon_sel_margin_left => 2,
                    ViewItemParams::icon_sel_margin_top => 0,
                    ViewItemParams::icon_margin_right => 15,
                    ViewItemParams::item_paint_caption_within_icon => false,
                    ViewItemParams::item_paint_caption => false,
                ),
                PluginRegularFolderItem::media_url => $item['media_url']
                    )
            );
        }

        return DuneLists::build_img_list($items, $actions);
    }
    
    function index($confing_path, $video_id = 0)
    {
        $video_category_id = 837;
        $url = Rise::$config->load('narkomsu.categories.video.link').$video_category_id;

        $content = file_get_contents($url);
        
        $pattern = '{[^<strong>]<a.*?href="((?:category/)?video/[0-9]+)"\s+class="preview".*?>.*?<img.*?src="(.*?)".*?</a>.*?<strong>.*?<a.*?href=".*?".*?title="(.*?)">(.*?)</a>}is';
        $count = preg_match_all($pattern, $content, $matches);
        $videos = array();
        if($count)
        {
            for($i=0;$i<$count;$i++)
            {
                $videos[] = array(
                    'link'=>$matches[1][$i],
                    'image'=>$matches[2][$i],
                    'alt'=>$matches[3][$i],
                    'title'=>$matches[4][$i],
                );
            }
        }
        else
            echo 'No matches found';
    }
    
    
    
    public function getLoadingItems()
    {
        $items = array($this->getLoadingItemArr());
        
        return array(
            PluginRegularFolderRange::total => count($items),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => true,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $items
        );
    }
    
    public function getLoadingItemArr()
    {
        return array
        (
                PluginRegularFolderItem::caption => 'Загрузка...',
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::item_paint_icon => false,
                    ViewItemParams::icon_path => 'gui_skin://large_icons/movie.aai',
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_detailed_icon_path => 'missing://',
                ),
                PluginRegularFolderItem::media_url => 'dummy'
            );
    }
    
    /**
     *
     * @param type $input
     * @return type 
     */
    function input(&$input)
    {
        if (isset($input->control_id))
        {
            $control_id = $input->control_id;
            switch ($control_id)
            {
                case "remove_fav":
                    if (isset($input->video_url))
                    {
                        FavoritesList::delete('fav_video' . $input->video_url);
                    } else
                    {
                        preg_match('/.*?\/(.\S*)/', $input->selected_media_url, $matches);

                        FavoritesList::delete('fav_video' . $matches[1]);
                    }
                    return ActionFactory::invalidate_folders(array($input->parent_media_url), UserInputHandlerRegistry::create_action($this, 'del_fav_complite'));
                case "add_to_fav":

                    if (!isset($input->video_url))
                    {
                        preg_match('/.*?\/(.\S*)/', $input->selected_media_url, $matches);
                        $input->video_url = $matches[1];
                    }

                    $data = $this->getVideoInfo($input->video_url);

                    FavoritesList::set('fav_video' . $input->video_url, array('poster' => $data['image'], 'media_url' => get_class($this) . '->details/' . $input->video_url, 'title' => $data['title']));

                    return ActionFactory::invalidate_folders(array($input->parent_media_url), UserInputHandlerRegistry::create_action($this, 'add_fav_complite'));
                case 'add_fav_complite':
                    return ActionFactory::show_title_dialog('Видео добавлено в избранное');
                case 'del_fav_complite':
                    return ActionFactory::show_title_dialog('Видео было удалено из избранного');
                case 'add_to_templates':
                    preg_match('/.*?\/(\S*)\//', $input->selected_media_url, $matches);

                    $n = Cookie::get('templ_count', 0);
                    Cookie::set('templ_count', ++$n);
                    Cookie::set('templ_video_search_text' . $n, urldecode($matches[1]));

                    return ActionFactory::invalidate_folders(array($input->parent_media_url), UserInputHandlerRegistry::create_action($this, 'add_templ_complite'));
                case 'add_templ_complite':
                    return ActionFactory::show_title_dialog('Шаблон для поиска был добавлен');
                case 'remove_search':
                    preg_match('/.*?\/.*?\/(\d*)/', $input->selected_media_url, $matches);
                    Cookie::delete('search_text' . $matches[1]);

                    return ActionFactory::invalidate_folders(array($input->parent_media_url), UserInputHandlerRegistry::create_action($this, 'del_search_complite'));
                case 'del_search_complite':
                    return ActionFactory::show_title_dialog('Запрос поиска был успешно удалён');
                case 'remove_template':
                    preg_match('/.*?\/.*?\/(\d*)/', $input->selected_media_url, $matches);

                    Cookie::delete('templ_video_search_text' . $matches[1]);

                    return ActionFactory::invalidate_folders(array($input->parent_media_url), UserInputHandlerRegistry::create_action($this, 'del_template_complite'));
                case 'del_template_complite':
                    return ActionFactory::show_title_dialog('Шаблон поиска был успешно удалён');
            }
        }
    }
    
  /**
     *
     * @return type 
     */
    function history()
    {
        $items = array();

        foreach (get_object_vars(Cookie::$cookie) as $key => $value)
        {
            preg_match('/^search_text(\d*)/', $key, $matches);

            if (isset($matches[1]) && !empty($matches[1]))
            {
                array_push($items, array(
                    PluginRegularFolderItem::caption => 'Поиск [' . $matches[1] . ']: ' . $value,
                    PluginRegularFolderItem::view_item_params => array
                        (
                        ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
                        ViewItemParams::item_layout => HALIGN_LEFT,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::icon_dx => 20,
                        ViewItemParams::icon_dy => -5,
                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                        ViewItemParams::item_caption_width => 1550
                    ),
                    PluginRegularFolderItem::media_url => 'NarkomSu_Category_Video_Search->seach_result/' . urlencode($value) . '/' . $matches[1]
                        )
                );
            }
        }

        $items = array_reverse($items); // last are first.

        $elements = array
            (
            PluginRegularFolderRange::total => count($items),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => false,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $items
        );


        return DuneLists::build_text_list($elements, DuneLists::get_search_action_map($this));
    }

    /**
     *
     * @return type 
     */
    function templates()
    {
        $items = array();

        foreach (get_object_vars(Cookie::$cookie) as $key => $value)
        {
            preg_match('/^templ_video_search_text(\d*)/', $key, $matches);

            if (isset($matches[1]) && !empty($matches[1]))
            {
                array_push($items, array(
                    PluginRegularFolderItem::caption => 'Шаблон поиска [' . $matches[1] . ']: ' . $value,
                    PluginRegularFolderItem::view_item_params => array
                        (
                        ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
                        ViewItemParams::item_layout => HALIGN_LEFT,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::icon_dx => 20,
                        ViewItemParams::icon_dy => -5,
                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                        ViewItemParams::item_caption_width => 1550
                    ),
                    PluginRegularFolderItem::media_url => 'NarkomSu_Category_Video_Search->seach_result/' . urlencode($value) . '/' . $matches[1]
                        )
                );
            }
        }

        $items = array_reverse($items); // last are first.

        $elements = array
            (
            PluginRegularFolderRange::total => count($items),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => false,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $items
        );


        return DuneLists::build_text_list($elements, DuneLists::get_templates_action_map($this));
    }

    
       /**
     *
     * @param type $title
     * @param type $year 
     */
    function getVideoInfoKinoPoisk($title, $year)
    {
        $curl = curl_init();

        $url="http://www.kinopoisk.ru/index.php";

        curl_setopt($curl,CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_COOKIESESSION, TRUE);
        curl_setopt($curl, CURLOPT_COOKIEFILE, "cookiefile");
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($curl, CURLOPT_ENCODING, 'gzip,deflate');
        curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.11 (KHTML, like Gecko) Chrome/17.0.963.56 Safari/535.11');
        curl_setopt($curl,CURLOPT_POST,TRUE);
//        curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 2);
        curl_setopt($curl,CURLOPT_POSTFIELDS,"level=7&from=forma&result=adv&m_act[from]=forma&m_act[what]=content&m_act[find]=$title&m_act[year]=$year");

        $content = curl_exec($curl);

        $content = iconv("CP1251", "UTF-8", $content);
        preg_match('/<h1 style="margin: 0; padding: 0" class="moviename-big" itemprop="name">(.*?)<\/h1>/', $content, $m_title);

        if(!isset($m_title[1]))
        {
            preg_match('{Скорее всего, вы ищете:.*?<p class="pic"><a href="(.*?)\/sr\/1\/"}is', $content, $m_redir_url);
            $new_url = $m_redir_url[1];

            if(isset($m_redir_url[1]))
            {
                $curl = curl_init();
                
                curl_setopt($curl,CURLOPT_URL, "http://www.kinopoisk.ru$new_url");
                curl_setopt($curl, CURLOPT_COOKIESESSION, TRUE);
                curl_setopt($curl, CURLOPT_COOKIEFILE, "cookiefile");
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
//                curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 1);
                curl_setopt($curl, CURLOPT_ENCODING, 'gzip,deflate');
                curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.11 (KHTML, like Gecko) Chrome/17.0.963.56 Safari/535.11');
                
                $content = curl_exec($curl);
            }
        }
        
        $content = iconv("CP1251", "UTF-8", $content);
        preg_match('/<h1 style="margin: 0; padding: 0" class="moviename-big" itemprop="name">(.*?)<\/h1>/', $content, $m_title);
        $title = trim(strip_tags($m_title[1]));
        
        preg_match('{страна(.*?)<\/a>}is', $content, $m_country);
        $country = trim(strip_tags($m_country[1]));
        
        
        preg_match('{режиссер(.*?)<\/a>}is', $content, $m_directors);
        $directors = trim(strip_tags($m_directors[1]));
        
        preg_match('{жанр<\/td>(.*?)<\/td>}is', $content, $m_ganres);
        $ganres = trim(strip_tags($m_ganres[1]));
       
        preg_match('{В главных ролях:(.*?)<\/div>}is', $content, $m_actors);
        $actors = str_replace(array("\n", '  '), array('', ' '), trim(strip_tags($m_actors[1])));
        
        preg_match('{<div class="brand_words" itemprop="description">(.*?)<\/div>}is', $content, $m_descr);
        $descr = htmlspecialchars_decode(trim(strip_tags($m_descr[1])));
        
        return  isset($m_title[1]) ? array(
                'title' => html_entity_decode($title) ,
                'country' => html_entity_decode($country),
                'directors' => html_entity_decode($directors),
                'ganres' => html_entity_decode($ganres),
                'actors' => html_entity_decode($actors),
                'descr' => html_entity_decode($descr),
                ) : false;
      }
    
    /**
     *
     * @param type $video_id
     * @return boolean 
     */
    function getVideoInfo($video_url)
    {
        $currnet_confing_path = Cookie::get('currnet_confing_path');
        
        $v = Rise::$config->load($currnet_confing_path.'.details_link');
        $detail_link = empty($v) ? Rise::$config->load('narkomsu.default_detail_link') : $v;
        
        $url = $this->video_details_url = 'http://' . Rise::$config->load('narkomsu.host') . $detail_link .'/'. $video_url;

        try
        {
            $content = file_get_contents($url);
//            hd_print($content);
        } catch (Exception $e){}

        
        $regexp = '{left--><img src="(.*?)" align="left" alt="(.*?)(?(?=[\/]).*?)(?(?=[\(|\s](\d\d\d\d)[\)\s].*?(\d*))[\(|\s](\d\d\d\d)[\)\s].*?(\d*))"}si';
        preg_match_all($regexp, $content, $matches);
        
        // get series urls.
        $regexp = '{<iframe src="(.*?)"}si';
        preg_match_all($regexp, $content, $series);
        if(!isset($series[1][0]))
        {
            $regexp = '{vk\("(.*?)"\)}si';
            preg_match_all($regexp, $content, $series);
        }
            
        // get series titles.
        $regexp = '{<b>(.*?)</b><br\ /><br \/><iframe}i';
        preg_match_all($regexp, $content, $series_names);
        
        $serias_urls = array();
        $first_url = '';    
        if(isset($series[1][0]))
        {
            foreach($series[1] as $k=>$v)
            {
                if(empty($first_url))
                    $first_url = $v;
                
                if(isset($series_names[1][$k]))
                {
                    $serias_urls[trim(strip_tags($series_names[1][$k]))] = $v;
                }
                else
                {
                    $serias_urls[$k + 1] = $v;
                }
            }
        }
        
        
        $pattern = "((Режиссёр:|Режиссер:)(<[^<]+?>|\s)(.*?)<[^<]+?>)";
        preg_match($pattern, $content, $details);
        $directors = isset($details[count($details) - 1]) ? trim(strip_tags($details[count($details) - 1])) : ''; 

        $pattern = "((В ролях:)(<[^<]+?>|\s)(.*?)<[^<]+?>)";
        preg_match($pattern, $content, $details);
        $actors = isset($details[count($details) - 1]) ? trim(strip_tags($details[count($details) - 1])) : ''; 


        $pattern = "((О фильме:|Описание:|Описание фильма)(.*?)</td>)si";
        preg_match($pattern, $content, $details);
        $description = isset($details[count($details) - 1]) ? trim(strip_tags($details[count($details) - 1])) : ''; 

        
        if (isset($matches[1][0]))
        {
            $image_path = 'http://' . Rise::$config->load('narkomsu.host') . trim(strip_tags($matches[1][0]));
            
            $videoInfo = array(
                'id' => $video_url,
                'title' => html_entity_decode(trim(strip_tags($matches[2][0]))),
                'image' => $image_path,
                'genre' => '',
                'year' => html_entity_decode(trim(strip_tags($matches[3][0]))),
                'country' => '',
                'directors' => html_entity_decode($directors),
                'description' => html_entity_decode($description),
                'file' => $first_url, 
                'original_name' => '',
                'actors' => html_entity_decode($actors),
                'film_length' => '',
                'quality' => html_entity_decode(trim(strip_tags($matches[4][0]))),
                'series' => $serias_urls,
            );
        } 
        else
        {
            $videoInfo = array(
                'id' => $video_id,
                'title' => '', 
                'image' => '',
                'genre' => '',
                'year' => '', 
                'country' => '',
                'description' => '',
                'directors' => '',
                'file' => '',
                'original_name' => '',
                'actors' => '',
                'film_length' => '',
                'quality' => '',
                'series' => array(),
            );
        }
        
        return $videoInfo;
    }
    
    /**
     *
     * @param type $video_id
     * @return null 
     */
    function details($video_url)
    {
        $movie = $this->getVideoInfo($video_url);        
        
        $kino_info = $this->getVideoInfoKinoPoisk($movie['title'], $movie['year']);
        
        if($kino_info !== false)
        {
            $movie['title'] = $kino_info['title'];
            $movie['country'] = $kino_info['country'];
            $movie['directors'] = $kino_info['directors'];
            $movie['genre'] = $kino_info['ganres'];
            $movie['actors'] = $kino_info['actors'];
            $movie['description'] = $kino_info['descr'];
        }
        
        $is_fav = FavoritesList::get('fav_video' . $video_url);

        $right_button_caption = $is_fav ? 'Удалить с избранного' : 'Добавить в избранное';
        $right_button_action = $is_fav ? 'remove_fav' : 'add_to_fav';
        

        $quality = !empty($movie['quality']) ? ' HD '. $movie['quality'] : '';
        $movie_folder_view = array(
            PluginMovieFolderView::movie => array(
                PluginMovie::name => html_entity_decode($movie['title']), // . $quality,
                PluginMovie::name_original => html_entity_decode($quality), //$movie['original_name'],
                PluginMovie::description => html_entity_decode($movie['description']),
                PluginMovie::poster_url => html_entity_decode($movie['image']),
//                PluginMovie::length_min => $movie['film_length'],
                PluginMovie::year => html_entity_decode($movie['year']),
                PluginMovie::directors_str => html_entity_decode($movie['directors']),
                //PluginMovie::scenarios_str => '....',
                PluginMovie::actors_str => html_entity_decode($movie['actors']),
                PluginMovie::genres_str => html_entity_decode($movie['genre']),
                PluginMovie::rate_imdb => '',
                PluginMovie::rate_kinopoisk => '',
                PluginMovie::rate_mpaa => '',
                PluginMovie::country => html_entity_decode($movie['country']),
                PluginMovie::budget => ''
            ),
            PluginMovieFolderView::has_right_button => true,
            PluginMovieFolderView::right_button_caption => $right_button_caption,
            PluginMovieFolderView::right_button_action => UserInputHandlerRegistry::create_action($this, $right_button_action, array('video_url' => $video_url)),
            PluginMovieFolderView::has_multiple_series => count($movie['series']) > 1,
            PluginMovieFolderView::series_media_url => get_class($this). '->series/'.  urlencode(json_encode($movie['series'])) . '/' . urlencode($movie['title']) . '/' . urlencode($movie['image']) . '/' . urlencode($movie['description'])
        );

        return array(
            PluginFolderView::multiple_views_supported => false,
            PluginFolderView::archive => null,
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_MOVIE,
            PluginFolderView::data => $movie_folder_view,
        );
    }    

}
?>
