<?php


class NarkomSu_Category_Video extends NarkomSu_Category 
{
    const ID = 'NarkomSu_Category_Video_ID';    
    
    protected $page = 0;
    protected $playVideoFile = null;
    protected $video_details_url = '';
    protected static $vod_play_action = array
        (
        GuiAction::handler_string_id => PLUGIN_VOD_PLAY_ACTION_ID,
        GuiAction::caption => 'Play'
    );
    protected static $folder_open_action = array
        (
        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
        GuiAction::caption => 'Play'
    );
    protected $data;
    protected $currnet_confing_path; // category.unit_name

    function __construct()
    {
        parent::__construct();
    }

    
    /**
     *
     * @param type $video_id
     * @return type 
     */
    function getVideoFileInfo($video_id)
    {
        $currnet_confing_path = Cookie::get('currnet_confing_path');
        
        $v = Rise::$config->load($currnet_confing_path.'.details_link');
        $detail_link = empty($v) ? Rise::$config->load('narkomsu.default_source_link') : $v;
        
        $url = $this->video_details_url = 'http://' . Rise::$config->load('narkomsu.host') . $detail_link . $video_id;

        try
        {
            $content = file_get_contents($url);
//            hd_print($content);
        } catch (Exception $e)
        {
            hd_print($e->getMessage());
        }

        preg_match_all("{file: '(.*?)'.*?description:.*?</b>-(.*?).mp4}si", $content, $matches);
        
        if(!isset($matches[1][0]))
            preg_match_all("{file: '(.*?)'}si", $content, $matches);
        
        if (isset($matches[1][0]))
        {
            $videoInfo = array(
                'id' => $video_id,
                'file' => trim(strip_tags($matches[1][0])),
                'series' => count($matches[1]) > 0 ? array_combine($matches[2], $matches[1]) : array()
            );
        } else
        {
            $videoInfo = array(
                'id' => $video_id,
                'file' => '',
                'series' => array(),
            );
        }
        
        return $videoInfo;
    }
    
    

    public function index($confing_path, $video_id = 0)
    {
        $this->currnet_confing_path = $confing_path;
        Cookie::set('currnet_confing_path', $this->currnet_confing_path);
        $style = Cookie::get('current_list_style', 'image');

        if ($style != 'image')
        {
            $items = Screen::build_category($this->currnet_confing_path . '.childs');
        } else
        {
            $items = Screen::build_category_with_image($this->currnet_confing_path . '.childs');
            
        }

        Cookie::set('currnet_sub_video_id', $video_id); // is serial

        if (count($items) > 0)
        {
            $actions = array
                (
                GUI_EVENT_KEY_ENTER => array
                    (
                    GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                )
            );

            if ($style != 'image')
            {
                return DuneLists::build_category_text_list($items, $actions);
            } 
            else
            {
                
                return DuneLists::build_category_img_list($items, $actions);
            }
        }


        $this->page = 1;
        $this->data = array(); // for reloading items 


        $style = Cookie::get('current_list_video_style', '0');

        $add_to_fav_action = UserInputHandlerRegistry::create_action($this, 'add_to_fav');
        $add_to_fav_action['caption'] = 'Добавить в избранное';
        
        $actions = array
            (
            GUI_EVENT_KEY_ENTER => self::$folder_open_action,
            GUI_EVENT_KEY_PLAY => self::$folder_open_action,
            GUI_EVENT_KEY_D_BLUE => $add_to_fav_action,
        );

        
        switch ($style)
        {
            case 0:

                return DuneLists::build_text_list_with_reloading($this->getLoadingItems(), $actions);
            case 1:

                return DuneLists::build_img_with_details_list_with_reloading($this->getLoadingItems(), $actions);
            case 2:

                return DuneLists::build_img_list_with_reloading($this->getLoadingItems(), $actions);
            default:

                return DuneLists::build_text_list_with_reloading($this->getLoadingItems(), $actions);
                
        }
    }

    /**
     *
     * @param type $ndx
     * @return type 
     */
    function indexRegular($ndx = 0)
    {
        $this->currnet_confing_path = Cookie::get('currnet_confing_path');

        $url = 'http://' . Rise::$config->load('narkomsu.host') . Rise::$config->load($this->currnet_confing_path . '.link');

        $regexp = '{<div class="news-title" style="padding-bottom: 5px;"><a href="/(.*?)".*?>(.*?)</a>.*?<div id="news-id-.*?<img.*?src="(.*?)"}si';
        return $this->indexParrentRegular($url, $regexp, $ndx);
    }

    /**
     *
     * @param type $url
     * @param type $regexp
     * @param type $ndx
     * @return type 
     */
    function indexParrentRegular($url, $regexp, $ndx = 0)
    {
        if ((int) $ndx > 0)
            --$ndx;

        $moreItemsAvailable = false;

        $videos = $this->getData($url, $regexp, $ndx);

        $items = array();
        $total_num = count($this->data);

        $style = Cookie::get('current_list_video_style', '0');

        if ($videos === FALSE)
        {
            $items [] = $this->getItemNoMore();
        } else
        {
            $moreItemsAvailable = true;
            foreach ($videos as $video)
            {
                $items [] = array
                    (
                    PluginRegularFolderItem::caption => $video['caption'],
                    PluginRegularFolderItem::view_item_params => array
                        (
                        ViewItemParams::item_paint_icon => $style > 0,
                        ViewItemParams::icon_path => $video['image'],
                        ViewItemParams::item_detailed_icon_path => $video['image'],
                        ViewItemParams::item_paint_caption => !$style > 0,
                        ViewItemParams::item_paint_caption_within_icon => false,
                        ViewItemParams::item_layout => HALIGN_LEFT,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                    ),
                    PluginRegularFolderItem::media_url =>  $video['serial'] ?  
                        get_class($this) . '->index/'.$this->currnet_confing_path.'/' . $video['link']. '/':
                        get_class($this) . '->details/'.$video['link'],
                );
            }
            $items [] = $this->getLoadingItemArr();
            $total_num++;
        }

        $regularItems = array
            (
            PluginRegularFolderRange::total => $total_num,
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => $moreItemsAvailable,
            PluginRegularFolderRange::from_ndx => $ndx,
            PluginRegularFolderRange::items => $items
        );

        return $regularItems;
    }

    /**
     *
     * @param type $series 
     */
    function series($series, $title, $poster, $description)
    {
            $actions = array (
                GUI_EVENT_KEY_ENTER => $vod_play_action = array(
                GuiAction::handler_string_id => PLUGIN_VOD_PLAY_ACTION_ID,
                GuiAction::caption => 'Play'
            ), 
                GUI_EVENT_KEY_PLAY => $vod_play_action = array(
                GuiAction::handler_string_id => PLUGIN_VOD_PLAY_ACTION_ID,
                GuiAction::caption => 'Play'
            ), 
            );
        
            return array(
                PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_REGULAR,
                PluginFolderView::multiple_views_supported => false,
                PluginFolderView::data => array(
                    PluginRegularFolderView::async_icon_loading => true,
                    PluginRegularFolderView::initial_range =>
                    $this->build_series(json_decode(urldecode($series)), urldecode($title), urldecode($poster), urldecode($description)),
                    PluginRegularFolderView::view_params => array(
                        ViewParams::num_cols => 1,
                        ViewParams::num_rows => 10,
                        ViewParams::paint_details => false,
                    ),
                    PluginRegularFolderView::base_view_item_params => array(
                        ViewItemParams::item_paint_icon => true,
                        ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                        ViewItemParams::item_layout => HALIGN_LEFT,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::icon_dx => 20,
                        ViewItemParams::icon_dy => -5,
                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                        ViewItemParams::item_caption_width => 1550
                    ),
                    PluginRegularFolderView::not_loaded_view_item_params => array(),
                    PluginRegularFolderView::actions => $actions
                )
            );
    }

    /**
     *
     * @param type $ndx 
     */
    function seriesRegular($ndx = 0)
    {
        
    }
    
    /**
     *
     * @param type $series
     * @return type 
     */
    function build_series($series, $title, $poster, $description)
    {
        $total_num = 0;
        $folder_items = array();

        if (count($series) > 0)
        {
            $i = 0;
            foreach ($series as $seria_name => $file)
            {
                array_push
                        (
                        $folder_items, array
                    (
                    PluginRegularFolderItem::media_url =>
                            urlencode(json_encode(array
                                        (
                                            'file' => $file,
                                            'title' => $title,
                                            'seria_name' => $seria_name,
                                            'poster' => $poster,
                                            'description' => $description,
                                        )
                                    )
                    ),
                    PluginRegularFolderItem::caption => $seria_name,
                    PluginRegularFolderItem::view_item_params => array(
                        ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                        ViewItemParams::item_detailed_info => 'details'
                    )
                        )
                );
                ++$i;
            }

            $total_num = $i;
        }

        return array(
            PluginRegularFolderRange::total => $total_num,
            PluginRegularFolderRange::count => count($folder_items),
            PluginRegularFolderRange::more_items_available => false,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $folder_items
        );
        
        
        }

    
    function play($film)
    {
        $video_url = Url::prepareVideoUrl($film['file']);

        return array
            (
            PluginVodInfo::name => $film['selected_seria'],
            PluginVodInfo::description => $film['description'],
            PluginVodInfo::poster_url => $film['poster'],
            PluginVodInfo::initial_series_ndx => 0,
            PluginVodInfo::series => array
                (
                array
                    (
                    PluginVodSeriesInfo::name => 'Video',
                    PluginVodSeriesInfo::playback_url => $video_url,
                    PluginVodSeriesInfo::playback_url_is_stream_url => true
                )
            ),
            PluginVodInfo::buffering_ms => BUFFERING_MS,
            PluginVodInfo::ip_address_required => TRUE,
            PluginVodInfo::valid_time_required => FALSE,
        );
        
    }
        
    
    
    /**
     *
     * @param type $video
     * @return type 
     */
    private function fillVideoFiles($video)
    {
        $items [] = array
            (
            PluginRegularFolderItem::caption => $video['file'],
            PluginRegularFolderItem::view_item_params => array(
                ViewItemParams::item_paint_icon => FALSE,
                ViewItemParams::item_layout => HALIGN_LEFT,
                ViewItemParams::icon_valign => VALIGN_CENTER,
                ViewItemParams::item_paint_caption_within_icon => false,
                ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
            ),
            PluginRegularFolderItem::media_url => get_class($this) . '->play/' . base64_encode($video['file'])
        );


        return array
          (
            PluginRegularFolderRange::total => count($items),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => false,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $items
        );
    }

    /**
     *
     * @param type $url
     * @param type $regexp
     * @param type $ndx
     * @return boolean 
     */
    function getData($url, $regexp, $ndx)
    {
        if ($ndx < count($this->data))
        {
            return array_slice($this->data, $ndx);
        }

        $videos = $this->getNextData($url, $regexp, $ndx);

        if ($videos === FALSE)
        {
            return FALSE; // no more items;
        }

        foreach ($videos as $v)
        {
            array_push($this->data, $v);
        }
        $this->page++;

        if ($ndx < count($this->data))
            return array_slice($this->data, $ndx);

        return array();
    }

    /**
     *
     * @param string $url
     * @param type $regexp
     * @param type $ndx
     * @return type 
     */
    function getNextData($url, $regexp, $ndx)
    {
        if(strpos($url, '?') === false)
        {
            $url .= 'page/' . $this->page .'/';
            
            $str = file_get_contents($url);
            preg_match_all($regexp, $str, $out);

            $items = array();
            if (isset($out[1][0]))
            {
                for ($i = 0; $i < count($out[1]); $i++)
                {
                    $image_path = str_replace('http://narkom.su', '', strip_tags($out[3][$i]));
                         
                    $image_path = 'http://' . Rise::$config->load('narkomsu.host') . $image_path;

                    $items [] = array(
                        'link' => trim(strip_tags($out[1][$i])),
                        'image' => $image_path,
                        'caption' => trim(strip_tags($out[2][$i])),
                        'serial' => false,
                    );
                }
            }

            return count($items) == 0 ? false : $items;
        }
        else
        {
            $url .= '&search_start=' . $this->page;
            
            $str = file_get_contents($url);
            preg_match_all($regexp, $str, $out);

            $items = array();
            $last_link = Cookie::get('start_founded_link', '');

            if (isset($out[1][0]) && $last_link != $out[1][0])
            {
                for ($i = 0; $i < count($out[1]); $i++)
                {
                    $image_path = 'http://' . Rise::$config->load('narkomsu.host') . strip_tags($out[2][$i]);

                    $items [] = array(
                        'link' => trim(strip_tags($out[1][$i])),
                        'image' => $image_path,
                        'caption' => trim(strip_tags($out[3][$i])),
                        'serial' => false,
                    );
                }
            }

            Cookie::set('start_founded_link', trim(strip_tags($out[1][0])));

            return count($items) == 0 ? false : $items;
        }
    }

    /**
     *
     * @return type 
     */
    public function getItemNoMore()
    {
        return array
            (
            PluginRegularFolderItem::caption => 'Больше ничего не найдено...',
            PluginRegularFolderItem::view_item_params => array
                (
                ViewItemParams::item_paint_icon => false,
                ViewItemParams::icon_path => 'gui_skin://large_icons/movie.aai',
                ViewItemParams::item_layout => HALIGN_LEFT,
                ViewItemParams::icon_valign => VALIGN_CENTER,
                ViewItemParams::item_detailed_icon_path => 'missing://',
            ),
            PluginRegularFolderItem::media_url => 'dummy'
        );
    }
}
?>
