<?php


class NarkomSu_Category_Video_Search extends NarkomSu_Category_Video 
{
    const ID = 'NarkomSu_Category_Video_Search_ID';
    private $searh_text;
    
    
    function input(&$input)
    {
        if(isset($input->control_id))
        {
            $control_id = $input->control_id;
            switch ($control_id)
            {
                case 'NarkomSu_Category_Video_Search->seach':

                    $new_value = $input->{$control_id};
                    
                    return array(
                        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                        GuiAction::data => array(
                            PluginOpenFolderActionData::media_url => get_class($this).'->seach_result/'.  urlencode($new_value),
                            PluginOpenFolderActionData::caption => $new_value,
                        )
                    );
            }
        }
        
        return parent::input($input); // favorites functions.
    }
    
    /**
     *
     * @param type $searh_base64 
     */
    function seach_result($searh_text = NULL, $search_id = 0)
    {
        $this->searh_text = urldecode($searh_text);
        Cookie::set('search_text', $this->searh_text);
        
        $n = Cookie::get('search_count', 0);
        if($n % 30 == 0)
        {
            // Deleting first searched 15 points.
            for($i = ($n - 15); $i >= ($n - 30); $i--)
                Cookie::delete('search_text'.$i);
        }    
        Cookie::set('search_count', ++$n);
        Cookie::set('search_text'.$n, $this->searh_text);
        
        $this->page = 1;
        $this->data = array();
        
        $add_to_fav_action = UserInputHandlerRegistry::create_action($this, 'add_to_fav');
        $add_to_fav_action['caption'] = 'Добавить в избранное';
        
        $actions = array
            (
            GUI_EVENT_KEY_ENTER => self::$folder_open_action,
            GUI_EVENT_KEY_PLAY => self::$folder_open_action,
            GUI_EVENT_KEY_D_BLUE => $add_to_fav_action,
        );

        $style = Cookie::get('current_list_video_style', '0');
        
        switch ($style)
        {
            case 0:
                return DuneLists::build_text_list_with_reloading($this->getLoadingItems(), $actions);
            case 1:
                return DuneLists::build_img_with_details_list_with_reloading($this->getLoadingItems(), $actions);
            case 2:
                return DuneLists::build_img_list_with_reloading($this->getLoadingItems(), $actions);
            default:
                return DuneLists::build_text_list_with_reloading($this->getLoadingItems(), $actions);
        }
    }
    
    /**
     *
     * @param type $ndx
     * @return type 
     */
    function seach_resultRegular($ndx = 0)
    {
        $this->searh_text = Cookie::get('search_text');
        $url = 'http://' . Rise::$config->load('narkomsu.host') . Rise::$config->load('narkomsu.start_page.search.link') . urlencode($this->searh_text);
        $regexp = '{<div class="news-title"><a href="http://narkom.su/(.*?)".*?<div id=\'news-id.*?<img src="(.*?)".*?alt="(.*?)"}si';
        
        return $this->indexParrentRegular($url, $regexp, $ndx);
    }
    
    
    /**
     *
     * @return type 
     */
    function index($confing_path, $video_id = 0)
    {
        $defs = array();

        ControlFactory::add_vgap($defs, 50);

        ControlFactory::add_label($defs, "            ", "Введите часть названия фильма:");

        UserInputHandlerRegistry::create_action($this, 'do_search');

        $this->add_text_field($defs, 'NarkomSu_Category_Video_Search->seach', "", Cookie::get('search_text'), 0, 0,  1, 0, 1550, true, 0);

        $folder_view = array(
            PluginControlsFolderView::defs => $defs,
            PluginControlsFolderView::initial_sel_ndx => - 1,
        );

        return array(
            PluginFolderView::multiple_views_supported => false,
            PluginFolderView::archive => null,
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_CONTROLS,
            PluginFolderView::data => $folder_view,
        );
    }
    
    /**
     *
     * @param type $defs
     * @param type $name
     * @param type $title
     * @param type $initial_value
     * @param type $numeric
     * @param type $password
     * @param type $has_osk
     * @param type $always_active
     * @param type $width
     * @param type $need_confirm
     * @param type $need_apply 
     */
    public function add_text_field(&$defs, $name, $title, $initial_value, $numeric, $password, $has_osk, $always_active, $width, $need_confirm = false, $need_apply = false)
    {
        ControlFactory::add_text_field($defs, $this, null, $name, $title, $initial_value, $numeric, $password, $has_osk, $always_active, $width, $need_confirm, $need_apply);
    }
}



